/* ==========================================================================
*    : ̼
*    : 2006.09.19
* 
*      :  
* ǻ : 
*===========================================================================*/
#pragma once

//#include <atltime.h>
#include "ZipArchive.h"

///  ð
class cFileTime
{
public:
	cFileTime();
	cFileTime( time_t time );
	cFileTime( const FILETIME& time );

	const FILETIME& GetFileTime();

//	void operator =( const cFileTime& that );

protected:
	FILETIME mFileTime;
};

///  ȿ ִ  
class cFileInPackInfo
{
	friend class cFilePack;

public:
	cFileInPackInfo() {}
	~cFileInPackInfo() {}

	bool SetPathName( LPCTSTR pathName );
	void SetWriteTime( const time_t& time );

	const cStringT&  GetPathName() const;
	unsigned int	 GetSize() const;
	const cFileTime& GetWriteTime() const;
	bool			 IsDirectory() const;
	time_t			 GetUnixWriteTime();
	
	FILETIME*		 GetWriteTimeInExtraBuf();
	WORD			 GetExtraFieldSize();
	CZipString		 GetComment();

protected:
	void UpdateFromHeader();

protected:
	/// 
	CZipFileHeader mHeader;

	/// ̸
	cStringT mPathName;

	/// ð
	cFileTime mWriteTime;
};

inline CZipString cFileInPackInfo::GetComment()
{
	return mHeader.GetComment();
}

inline
WORD cFileInPackInfo::GetExtraFieldSize()
{
	return mHeader.GetExtraFieldSize();
}

inline
time_t cFileInPackInfo::GetUnixWriteTime()
{
	return mHeader.GetTime();
}

inline
const cStringT& cFileInPackInfo::GetPathName() const
{
	return mPathName;
}

inline
unsigned int cFileInPackInfo::GetSize() const
{
	return (unsigned int)mHeader.m_uUncomprSize;
}

inline
const cFileTime& cFileInPackInfo::GetWriteTime() const
{
	return mWriteTime;
}

inline
bool cFileInPackInfo::IsDirectory() const
{
	return mHeader.IsDirectory();
}

static BYTE SY_KEY_TABLE[64]=
{
	0x23, 0xbe, 0x84, 0xe1, 
	0x6c, 0xd6, 0xae, 0x52, 
	0x90, 0x49, 0xf1, 0xf1, 
	0xbb, 0xe9, 0xeb, 0xb3, 
	0xa6, 0xdb, 0x3c, 0x87, 
	0x0c, 0x3e, 0x99, 0x24, 
	0x5e, 0x0d, 0x1c, 0x06, 
	0xb7, 0x47, 0xde, 0xb3, 
	0x12, 0x4d, 0xc8, 0x43, 
	0xbb, 0x8b, 0xa6, 0x1f, 
	0x03, 0x5a, 0x7d, 0x09, 
	0x38, 0x25, 0x1f, 0x5d, 
	0xd4, 0xcb, 0xfc, 0x96, 
	0xf5, 0x45, 0x3b, 0x13, 
	0x0d, 0x89, 0x0a, 0x1c, 
	0xdb, 0xae, 0x32, 0x20
};

static BYTE MIX_TABLE[64] =
{
	58, 22, 59, 17, 
	45, 46, 36,  8, 
	57, 62, 18, 27, 
	37,  3, 37, 60, 
	52,  5, 19, 24, 
	40, 14, 11, 53, 
	5,  32, 25, 61, 
	23, 39, 10, 25, 
	54, 45, 16,  2, 
	9,  13, 40, 20, 
	9,  42, 57, 37, 
	8,  33,  0, 20,
	25, 44, 33, 38, 
	30, 14, 33, 48, 
	28, 62, 25, 49, 
	31, 34, 37, 34
};

///  
class cFilePack
{
public:
	///  
	enum eOpenMode
	{
		OPEN_READONLY = CZipArchive::zipOpenReadOnly,
		OPEN = CZipArchive::zipOpen,
		CREATE = CZipArchive::zipCreate
	};

public:
	cFilePack();
	~cFilePack();

	/// 
	bool Open( LPCTSTR pathName, eOpenMode mode );

	/// ݱ
	void Close();

	/// н
	///    ,  ϰų ߰ϱ  Ѵ.
	bool SetPassword( LPCTSTR password = 0 );

	/// Decrypt н带 ִ´.
	bool SetPasswordEx( const char* password = 0, int len = 0 );

	///  ˻
	///  ε Ѵ. ϸ -1 Ѵ.
	int FindFile( const cStringT& pathName, bool caseSensitive = false );

	///  
	void DeleteFile( int index );
	void DeleteFiles( const tArray<int>& indexArray );
	void DeleteFiles( CZipWordArray& indexArray );
	void DeleteFiles( CZipStringArray *stringArray );


	///  ̸ 
	bool RenameFile( int index, const cStringT& newPathName );

	///  
	bool OpenFile( int index );

	///  ݱ
	bool CloseFile();

	///  б
	/// OpenFile() Լ  ־ Ѵ.
	/// ϸ  о Ʈ  ϰ, ϸ 0 Ѵ.
	unsigned int ReadFile( void* buffer, unsigned int size );

	///   
	/// compressLevel :  
	/// filePath : ش  Ϸκ ð  Ӽ ´.
	bool OpenNewFile( cFileInPackInfo& fi, int compressLevel = Z_NO_COMPRESSION, LPCTSTR filePath = 0 );

	///     ݱ
	bool CloseNewFile();

	///   ؼ 
	/// OpenNewFile() Լ  ־ Ѵ.
	bool WriteNewFile( const void* buffer, unsigned int size );

	///     ҿ 
	void Flush();

	///  ȴ 
	bool IsOpened();

	///   
	int GetNumFiles() const;

	///   
	bool GetFileInfo( cFileInPackInfo* fi, int index ) const;

	/// ߰ ޸ 
	const char*  SetExtraFieldEx(const char *pBuf, WORD iSize);

	///  ̸ ε 
	void  GetIndexes(const CZipStringArray &aNames, CZipWordArray& aIndexes);

	///  ̸ ε 
	int   GetIndex( LPCTSTR Names );

	/// ޸𸮿  Ǯ
	bool ExtractFileInMem(WORD uIndex, CZipMemFile& mf, bool bRewind = true, DWORD nBufSize = 65536);

	/// ޸𸮿 ִ  ѿ ߰ϱ.
	bool AddNewFile(CZipMemFile& mf, LPCTSTR lpszFileNameInZip,	int iComprLevel = -1, int iSmartLevel = CZipArchive::zipsmSafeSmart,	unsigned long nBufSize = 65536);
	
	bool SetFileComment(WORD uIndex, LPCTSTR lpszComment);

private:
	///  
	CZipArchive mZip;
};

inline
bool cFilePack::SetFileComment(WORD uIndex, LPCTSTR lpszComment)
{
	return mZip.SetFileComment( uIndex, lpszComment );
}

inline
int cFilePack::GetIndex( LPCTSTR Names )
{
	return mZip.FindFile( Names );
}

inline
bool cFilePack::AddNewFile( CZipMemFile& mf, LPCTSTR lpszFileNameInZip, int iComprLevel /* = -1 */, int iSmartLevel /* = CZipArchive::zipsmSafeSmart */, unsigned long nBufSize /* = 65536 */ )
{
	return mZip.AddNewFile( mf, lpszFileNameInZip, iComprLevel, iSmartLevel, nBufSize );
}

inline
bool cFilePack::ExtractFileInMem(WORD uIndex, CZipMemFile& mf, bool bRewind /* = true */, DWORD nBufSize /* = 65536 */)
{
	return mZip.ExtractFile( uIndex, mf, bRewind, nBufSize );
}

inline
void cFilePack::GetIndexes( const CZipStringArray &aNames, CZipWordArray& aIndexes )
{
	return mZip.GetIndexes( aNames, aIndexes );
}

inline
bool cFilePack::SetPassword( const charT* password )
{
	return mZip.SetPassword( password );
}

inline
bool cFilePack::SetPasswordEx( const char* password , int len )
{
 	char *pDecryptPassword;
 	pDecryptPassword = new char[len+1];
	pDecryptPassword[len] = 0;
	for( int idx = 0; idx < len; ++idx )
	{
		BYTE keyIdx = MIX_TABLE[ idx % 64 ];
		pDecryptPassword[idx] = password[idx] ^ SY_KEY_TABLE[keyIdx];
	}

 	bool ret = false; 

	charT *pUnicodeDecryptPassword;
	pUnicodeDecryptPassword = new charT[len+2];
	pUnicodeDecryptPassword[len+1] = 0;

#ifdef _UNICODE
	size_t lenDecrypt = ::strlen(pDecryptPassword);
	if( lenDecrypt == 0 )
		return ret;
	int iLen = ::MultiByteToWideChar( CP_ACP, MB_PRECOMPOSED, pDecryptPassword, lenDecrypt, NULL, 0 );
	if (iLen > 0)
	{
		assert( iLen+1 < (int)lenDecrypt+2 );
		iLen = ::MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, pDecryptPassword, -1, (LPWSTR)pUnicodeDecryptPassword, iLen+1 );
		assert(iLen != 0);
	}
	else
	{
		iLen --; // return -1
	}
#else
	#if (_MSC_VER >= 1400)
		_tcscpy_s( pUnicodeDecryptPassword, len+2, pDecryptPassword );	
	#else  
		_tcscpy( pUnicodeDecryptPassword, pDecryptPassword );	
	#endif
#endif

	ret = mZip.SetPassword( pUnicodeDecryptPassword );

	delete[] pDecryptPassword;
	delete[] pUnicodeDecryptPassword;

	return ret;
}

inline
bool cFilePack::IsOpened()
{
	return !mZip.IsClosed();
}

inline
int cFilePack::GetNumFiles() const
{
	return mZip.GetCount();
}

inline
const char* cFilePack::SetExtraFieldEx( const char *pBuf, WORD iSize )
{
	return mZip.SetExtraFieldEx( pBuf, iSize );
};

