/* ==========================================================================
*    : ̼
*    : 2006.09.21
* 
*      : ļ
* ߰ :
*			۾		۾	۾
*
* ǻ : ؽƮ  Ľϱ   ʿ Ѵ.
*===========================================================================*/
#pragma once

#include "Token.h"

class cLexer;
class cLexerW;


/// ļ
/// ؽƮ  Ľϱ   ʿ Ѵ.
class cParser
{
public:
	cParser();
	cParser( cLexer* lexer, const cString& fileName );
	virtual ~cParser();

	///  
	void SetLexer( cLexer* lexer );

	///  ̸ 
	void SetFileName( const cString& fileName );

	///  ū ´  
	bool ExpectTokenString( const char* str );
	bool ExpectTokenType( int type );

	/// ڿ Ľ
	cString ParseString();
	bool ParseString( cString* str );

	///  Ľ
	int ParseInt();
	bool ParseInt( int* out );

	/// Ǽ Ľ
	float ParseFloat();
	bool ParseFloat( float* out );

	///  
	cLexer* GetLexer() const;

	///  ̸ : 
	const char* GetFileName() const;

	///  ȣ 
	int GetLineNum() const;

protected:
	/// 
	cLexer* mpLexer;

	/// Ľ  ̸
	cString mFileName;

	/// ū
	cToken mToken;
};

inline void cParser::SetLexer( cLexer* lexer )
{
	mpLexer = lexer;
}

inline void cParser::SetFileName( const cString& fileName )
{
	mFileName = fileName;
}

inline cLexer* cParser::GetLexer() const
{
	return mpLexer;
}

inline int cParser::GetLineNum() const
{
	return mToken.mLine;
}


inline const char* cParser::GetFileName() const
{
	return mFileName.Cstr();
}

//---------------------------------------------------------------
class cParserW
{
public:
	cParserW();
	cParserW( cLexerW* lexer, const cStringW& fileName );
	virtual ~cParserW();

	///  
	void SetLexer( cLexerW* lexer );

	///  ̸ 
	void SetFileName( const cStringW& fileName );

	///  ū ´  
	bool ExpectTokenString( const wchar_t* str );
	bool ExpectTokenType( int type );

	/// ڿ Ľ
	cStringW ParseString();
	bool ParseString( cStringW* str );

	///  Ľ
	int ParseInt();
	bool ParseInt( int* out );

	/// Ǽ Ľ
	float ParseFloat();
	bool ParseFloat( float* out );

	///  
	cLexerW* GetLexer() const;

	///  ̸ : 
	const wchar_t* GetFileName() const;

	///  ȣ 
	int GetLineNum() const;

protected:
	/// 
	cLexerW* mpLexer;

	/// Ľ  ̸
	cStringW mFileName;

	/// ū
	cTokenW mToken;
};

inline void cParserW::SetLexer( cLexerW* lexer )
{
	mpLexer = lexer;
}

inline void cParserW::SetFileName( const cStringW& fileName )
{
	mFileName = fileName;
}

inline cLexerW* cParserW::GetLexer() const
{
	return mpLexer;
}

inline int cParserW::GetLineNum() const
{
	return mToken.mLine;
}

inline const wchar_t* cParserW::GetFileName() const
{
	return mFileName.Cstr();
}